Index: dll/shellext/netshell/lang/ru-RU.rc
===================================================================
--- dll/shellext/netshell/lang/ru-RU.rc	(revision 71615)
+++ dll/shellext/netshell/lang/ru-RU.rc	(working copy)
@@ -78,44 +78,44 @@
 
 IDD_NETWORKSETTINGSPAGE DIALOGEX 0, 0, 317, 143
 STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "ReactOS Setup"
+CAPTION "Установка ReactOS"
 FONT 8, "MS Shell Dlg"
 BEGIN
     ICON IDI_NET_SETUP, IDC_STATIC, 21, 10, 20, 20
-    LTEXT "Choose whether to use typical or custom settings:", IDC_STATIC, 53, 7, 240, 20
-    AUTORADIOBUTTON "Typical Settings", IDC_NETWORK_TYPICAL, 53, 27, 253, 20, WS_TABSTOP | WS_GROUP
-    AUTORADIOBUTTON "Custom Settings", IDC_NETWORK_CUSTOM, 53, 72, 253, 20, WS_TABSTOP
-    LTEXT "Creates network connetions using the Client for ReactOS Networks, File and Print Sharing for ReactOS Networks, and the TCP/IP transport protocol with automatic addressing.", IDC_STATIC, 65, 45, 240, 30
-    LTEXT "Allows you to manually configure network components.", IDC_STATIC, 65, 90, 243, 20
+    LTEXT "Выберите режим настройки сети:", IDC_STATIC, 53, 7, 240, 20
+    AUTORADIOBUTTON "Обычный режим настройки", IDC_NETWORK_TYPICAL, 53, 27, 253, 20, WS_TABSTOP | WS_GROUP
+    AUTORADIOBUTTON "Расширенный режим настройки", IDC_NETWORK_CUSTOM, 53, 72, 253, 20, WS_TABSTOP
+    LTEXT "Создает сетевые соединения, используя клиент для сетей ReactOS, Общие файлы и принтеры для сетей ReactOS и транспортный протокол TCP/IP с автоматической адресацией.", IDC_STATIC, 65, 45, 240, 30
+    LTEXT "Позволяет вам настроить сетевые компоненты вручную.", IDC_STATIC, 65, 90, 243, 20
 END
 
 IDD_NETWORKCOMPONENTPAGE DIALOGEX 0, 0, 317, 143
 STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "ReactOS Setup"
+CAPTION "Установка ReactOS"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    LTEXT "For Device:", IDC_STATIC, 33, 2, 100, 20
-    LTEXT "n/a", IDC_NETWORK_DEVICE, 75, 2, 253, 20
-    LTEXT "Components checked are used by this connection:", IDC_STATIC, 33, 12, 253, 20
+    LTEXT "Оборудование:", IDC_STATIC, 33, 2, 100, 20
+    LTEXT "н/д", IDC_NETWORK_DEVICE, 75, 2, 253, 20
+    LTEXT "Это соединение использует следующие компоненты:", IDC_STATIC, 33, 12, 253, 20
     CONTROL "", IDC_COMPONENT_LIST, "SysListView32", LVS_REPORT | LVS_SINGLESEL | LVS_SHOWSELALWAYS | LVS_NOCOLUMNHEADER | LVS_NOSORTHEADER | WS_BORDER | WS_TABSTOP, 33, 22, 250, 50
-    PUSHBUTTON "&Install...", IDC_NETWORK_INSTALL, 122, 75, 50, 14, WS_DISABLED | WS_TABSTOP
-    PUSHBUTTON "&Uninstall", IDC_NETWORK_UNINSTALL, 177, 75, 50, 14, WS_DISABLED | WS_TABSTOP
-    PUSHBUTTON "&Properties", IDC_NETWORK_PROPERTIES, 232, 75, 50, 14, WS_DISABLED | WS_TABSTOP
-    GROUPBOX "Description", IDC_STATIC, 33, 90, 250, 50, BS_GROUPBOX
+    PUSHBUTTON "&Установить...", IDC_NETWORK_INSTALL, 122, 75, 50, 14, WS_DISABLED | WS_TABSTOP
+    PUSHBUTTON "У&далить", IDC_NETWORK_UNINSTALL, 177, 75, 50, 14, WS_DISABLED | WS_TABSTOP
+    PUSHBUTTON "Сво&йства", IDC_NETWORK_PROPERTIES, 232, 75, 50, 14, WS_DISABLED | WS_TABSTOP
+    GROUPBOX "Описание", IDC_STATIC, 33, 90, 250, 50, BS_GROUPBOX
 END
 
 IDD_NETWORKDOMAINPAGE DIALOGEX 0, 0, 317, 143
 STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "ReactOS Setup"
+CAPTION "Установка ReactOS"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    LTEXT "Do you want this computer to be a member of a domain?\n\
-(You can obtain this information from your network administator.)", IDC_STATIC, 33, 2, 263, 50
-    AUTORADIOBUTTON "No, this computer will be part of a workgroup.", IDC_SELECT_WORKGROUP, 33, 32, 253, 20, WS_TABSTOP | WS_GROUP
-    AUTORADIOBUTTON "Yes, this computer will be part of a domain.", IDC_SELECT_DOMAIN, 33, 47, 253, 20, WS_TABSTOP
-    LTEXT "Workgroup or Domain Name:", IDC_STATIC, 33, 72, 126, 14
+    LTEXT "Вы хотите, чтобы этот компьютер был частью сетевого домена?\n\
+(Вы можете получить необходимую информацию у вашего сетевого администратора.)", IDC_STATIC, 33, 2, 263, 50
+    AUTORADIOBUTTON "Нет, этот компьютер находится в рабочей группе.", IDC_SELECT_WORKGROUP, 33, 32, 253, 20, WS_TABSTOP | WS_GROUP
+    AUTORADIOBUTTON "Да, этот компьютер будет частью сетевого домена.", IDC_SELECT_DOMAIN, 33, 47, 253, 20, WS_TABSTOP
+    LTEXT "Имя рабочей группы или домена:", IDC_STATIC, 33, 72, 126, 14
     EDITTEXT IDC_DOMAIN_NAME, 33, 82, 126, 14, WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL
-    LTEXT "NOTE: If this computer isn't going to be part of a network, you don't have sufficient rights to join a domain, or you don't know what to enter, then just choose workgroup for now. These options can be changed at a later time.", IDC_STATIC, 33, 107, 263, 50
+    LTEXT "Примечание: Если этот компьютер не надо присоединять к сети, или у вас нет прав для присоединения к сетевому домену, или вы не знаете, как к нему присоединиться, тогда выберите опцию рабочей группы. Эту опцию потом можно будет изменить.", IDC_STATIC, 33, 107, 263, 50
 END
 
 STRINGTABLE
@@ -165,12 +165,12 @@
 
 STRINGTABLE
 BEGIN
-    IDS_NETWORKSETTINGSTITLE "Network Settings"
-    IDS_NETWORKSETTINGSSUBTITLE "Installs network software used to connect to other networks, computers, and the Internet."
-    IDS_NETWORKCOMPONENTTITLE "Network Components"
-    IDS_NETWORKCOMPONENTSUBTITLE "Determine which networking components are used on your computer. To add new components, click on Install."
-    IDS_NETWORKDOMAINTITLE "Workgroup or Computer Domain"
-    IDS_NETWORKDOMAINSUBTITLE "A domain is a group of computers defined by a network administator. A workgroup is a group of computers sharing the same workgroup name."
-    IDS_REACTOS_SETUP "ReactOS Setup"
-    IDS_WZD_DOMAIN_NAME "Setup cannot continue until you\nenter the name of your domain\nor workgroup."
+    IDS_NETWORKSETTINGSTITLE "Настройки сети"
+    IDS_NETWORKSETTINGSSUBTITLE "Устанавливает сетевое программное обеспечение, необходимое для соединени с другими сетями, компьютерами или Интернетом."
+    IDS_NETWORKCOMPONENTTITLE "Сетевые компоненты"
+    IDS_NETWORKCOMPONENTSUBTITLE "Определяет, какие сетевые компоненты используются на вашем компьютере. Чтобы добавить новые, нажмите кнопку Установить."
+    IDS_NETWORKDOMAINTITLE "Рабочая группа или сетевой домен"
+    IDS_NETWORKDOMAINSUBTITLE "Сетевой домен - это группа компьютеров, определенная сетевым администратором. Рабочая группа - это группа компьютеров, у которых одинаковое имя рабочей группы."
+    IDS_REACTOS_SETUP "Установка ReactOS"
+    IDS_WZD_DOMAIN_NAME "Невозможно продолжить установку, т.к. вы\nне ввели имя вашей рабочей группы или домена."
 END