Index: base/applications/mscutils/servman/lang/ru-RU.rc
===================================================================
--- base/applications/mscutils/servman/lang/ru-RU.rc	(revision 72091)
+++ base/applications/mscutils/servman/lang/ru-RU.rc	(working copy)
@@ -339,6 +339,6 @@
 
 STRINGTABLE
 BEGIN
-    IDS_NOT_SAME_PASSWORD "The Passwords are not the same!"
-    IDS_INVALID_PASSWORD "Enter a valid Password!"
+    IDS_NOT_SAME_PASSWORD "Пароли не совпадают!"
+    IDS_INVALID_PASSWORD "Введите правильный пароль!"
 END
Index: base/applications/taskmgr/lang/ru-RU.rc
===================================================================
--- base/applications/taskmgr/lang/ru-RU.rc	(revision 72091)
+++ base/applications/taskmgr/lang/ru-RU.rc	(working copy)
@@ -57,7 +57,7 @@
         MENUITEM "&Завершение сеанса %s",         ID_SHUTDOWN_LOGOFF
         MENUITEM "С&мена пользователя\tWinKey+L", ID_SHUTDOWN_SWITCHUSER, GRAYED
         MENUITEM "Заб&локировать компьютер\tWinKey+L",      ID_SHUTDOWN_LOCKCOMPUTER
-        MENUITEM "&Disconnect",                   ID_SHUTDOWN_DISCONNECT, GRAYED
+        MENUITEM "&Отключить",                   ID_SHUTDOWN_DISCONNECT, GRAYED
         MENUITEM "С&нять компьютер с док-станции",               ID_SHUTDOWN_EJECT_COMPUTER, GRAYED
     END
     POPUP "&Справка"
Index: dll/shellext/acppage/ACPPage.rc
===================================================================
--- dll/shellext/acppage/ACPPage.rc	(revision 72091)
+++ dll/shellext/acppage/ACPPage.rc	(working copy)
@@ -64,10 +64,10 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
-/*
 #ifdef LANGUAGE_RU_RU
     #include "lang/ru-RU.rc"
 #endif
+/*
 #ifdef LANGUAGE_SK_SK
     #include "lang/sk-SK.rc"
 #endif
@@ -88,4 +88,4 @@
 #ifdef LANGUAGE_ZH_CN
     #include "lang/zh-CN.rc"
 #endif
-*/
\ No newline at end of file
+*/
Index: dll/shellext/acppage/lang/ru-RU.rc
===================================================================
--- dll/shellext/acppage/lang/ru-RU.rc	(nonexistent)
+++ dll/shellext/acppage/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,41 @@
+/* Russian language resource file by Stopkin Sergey (stopkin.sergey@gmail.com) */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+IDD_ACPPAGESHEET DIALOGEX 0, 0, 224, 226
+STYLE DS_SHELLFONT | WS_CHILD | WS_DISABLED | WS_CAPTION
+CAPTION "Compatibility"
+FONT 8, "MS Shell Dlg", 0, 0, 0x0
+BEGIN
+    LTEXT "Если у вас есть проблемы с запуском этой программы в ReactOS, выберите операционную систему, которой ReactOS будет представляться приложению. \ NУчтите, работа над этим модулем продолжается, и на данном этапе он ничего не будет делать." IDC_EXPLANATION, 7, 7 , 210, 31
+    GROUPBOX "Режим совместимости", IDC_COMPATGROUP, 7, 41, 210, 49
+    CHECKBOX "Запустить программу в режиме совместимости с:", IDC_CHKRUNCOMPATIBILITY, 18, 57, 188, 10, BS_AUTOCHECKBOX | WS_TABSTOP
+    COMBOBOX IDC_COMPATIBILITYMODE, 18, 70, 188, 85, CBS_HASSTRINGS | CBS_DROPDOWNLIST | WS_TABSTOP | WS_DISABLED
+    GROUPBOX "Параметры экрана", -1, 7, 99, 210, 61, BS_GROUPBOX | WS_DISABLED
+    CHECKBOX "Использовать 256 цветов", IDC_CHKRUNIN256COLORS, 18, 114, 188, 10, BS_AUTOCHECKBOX | WS_TABSTOP | WS_DISABLED
+    CHECKBOX "Использовать разрешение экрана 640x480", IDC_CHKRUNIN640480RES, 18, 129, 188, 10, BS_AUTOCHECKBOX | WS_TABSTOP | WS_DISABLED
+    CHECKBOX "Отключить визуальное оформление", IDC_CHKDISABLEVISUALTHEMES, 18, 144, 188, 10, BS_AUTOCHECKBOX | WS_TABSTOP | WS_DISABLED
+    PUSHBUTTON "Настроить режимы совместимости...", IDC_EDITCOMPATIBILITYMODES, 117, 167, 100, 15
+    CONTROL "Узнать больше о <A>совместимости программ</A>.", IDC_INFOLINK, "SysLink", WS_CHILD | WS_TABSTOP | WS_VISIBLE, 7, 207, 210, 10, WS_EX_NOPARENTNOTIFY
+END
+
+IDD_EDITCOMPATIBILITYMODES DIALOGEX 0, 0, 230, 139
+STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
+CAPTION "Изменить режимы совместимости"
+FONT 8, "MS Shell Dlg", 0, 0, 0x0
+BEGIN
+    EDITTEXT IDC_NEWCOMPATIBILITYMODE, 9, 6, 148, 14, ES_AUTOHSCROLL
+    LISTBOX IDC_COMPATIBILITYMODE, 9, 25, 148, 86, LBS_NOTIFY | LBS_NOINTEGRALHEIGHT | LBS_WANTKEYBOARDINPUT | WS_BORDER
+    PUSHBUTTON "&Добавить...", IDC_ADD, 162, 6, 60, 14, WS_DISABLED
+    PUSHBUTTON "&Редактировать...", IDC_EDIT, 162, 24, 60, 14, WS_DISABLED
+    PUSHBUTTON "&Удалить", IDC_DELETE, 162, 42, 60, 14, WS_DISABLED
+    PUSHBUTTON "&OK", IDOK, 95, 116, 60, 14
+    PUSHBUTTON "&Отмена", IDCANCEL, 162, 116, 60, 14
+END
+
+STRINGTABLE
+BEGIN
+    IDS_TABTITLE "Совместимость"
+    IDS_FAILED_NETWORK "Режим совместимости не может быть установлен для этой программы, потому что она находится на сетевом диске."
+    IDS_FAILED_PROTECTED "Режим совместимости не может быть использован для компонентов ReactOS."
+END
Index: dll/win32/iernonce/iernonce.rc
===================================================================
--- dll/win32/iernonce/iernonce.rc	(revision 72091)
+++ dll/win32/iernonce/iernonce.rc	(working copy)
@@ -23,6 +23,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_TR_TR
     #include "lang/tr-TR.rc"
 #endif
@@ -32,4 +35,3 @@
 #ifdef LANGUAGE_ZH_TW
     #include "lang/zh-TW.rc"
 #endif
-
Index: dll/win32/iernonce/lang/ru-RU.rc
===================================================================
--- dll/win32/iernonce/lang/ru-RU.rc	(nonexistent)
+++ dll/win32/iernonce/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,29 @@
+/* Russian language resource file by Stopkin Sergey (stopkin.sergey@gmail.com) */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE
+BEGIN
+    IDS_INVALIDFORMAT "Недопустимый формат записи %1 RunEx или RunOnceEx. Требуется использование вертикальной черты ('|') после имени функции. Также функция должна поддерживать WinMain() параметры"
+    IDS_LOADERROR "Произошла ошибка при загрузке %1. Возможно, файл не был установлен или он был поврежден."
+    IDS_CALLERROR "При вызове функции %1 из %2 произошла ошибка или исключение."
+    IDS_INCORRECTFORMAT "Недопустимый формат команды RunEx или RunOnceEx: %1. Команда выполнения оболочки должна начинаться с ||."
+    IDS_INCORRECTFORMAT "Неверный формат команды RunEx или RunOnceEx: %1. Команда выполнения для оболочки должна начинаться с ||."
+    IDS_EXECUTEERROR "Во время выполнения %1 произошла ошибка или исключение."
+    IDS_NOFUNCTION "Не удается найти функцию %1 в файле %2."
+    IDS_NODEPENDENCY "Не удалось загрузить требуемый файл %1."
+    IDS_SETUPERROR "Произошла ошибка при настройке 1%. Эта ошибка была занесена в журнал, установка будет продолжена"
+    IDS_INCOMPLETE "Предыдущая установка приложения не была завершена.\n\nВойдите в систему, используя учетную запись Администратора для завершения установки."
+    IDS_SETUP "ReactOS Setup"
+    IDS_SERVICEERROR "Некоторые службы не могут быть запущены. Программе установки необходимо перезагрузить систему для того, чтобы запустить службы."
+END
+
+IDD_DIALOG DIALOGEX 0, 0, 206, 166
+STYLE DS_MODALFRAME | DS_NOIDLEMSG | WS_POPUP | WS_VISIBLE | WS_CAPTION
+CAPTION "ReactOS Setup"
+FONT 8, "MS Shell Dlg"
+BEGIN
+    LTEXT "ReactOS настраивает следующие параметры:", -1, 36, 13, 163, 11
+    LISTBOX IDC_LB_ITEMS, 36, 32, 163, 127, LBS_NOTIFY | LBS_OWNERDRAWVARIABLE | LBS_HASSTRINGS | LBS_NOINTEGRALHEIGHT | WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_VSCROLL | WS_TABSTOP
+    ICON IDI_ICON, -1, 7, 7, 20, 20
+END