Index: applications/cmdutils/arping/arping.rc
===================================================================
--- applications/cmdutils/arping/arping.rc	(revision 72661)
+++ applications/cmdutils/arping/arping.rc	(working copy)
@@ -13,3 +13,6 @@
 #ifdef LANGUAGE_EN_US
     #include "lang/en-US.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
Index: applications/cmdutils/arping/lang/ru-RU.rc
===================================================================
--- applications/cmdutils/arping/lang/ru-RU.rc	(nonexistent)
+++ applications/cmdutils/arping/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,33 @@
+/*
+ * PROJECT:     ReactOS
+ * LICENSE:     Public Domain
+ * FILE:        applications/cmdutils/arping/lang/ru-RU.rc
+ * PURPOSE:     Russian Language File for arping
+ * TRANSLATOR:  Sergey Stopkin
+ */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE
+BEGIN
+    IDS_USAGE "\nИспользование: arping [-t] [-n число] -s ip-источника узел-назначения\n\n\
+Опции:\n\
+    -t             Отправка пакетов на указанный узел до команды прерывания.\n\
+                   Для прерывания - используйте Control-C.\n\
+    -n число       Число отправляемых запросов\n\
+    -s             Использовать IP источника.\n\n\0"
+    IDS_BAD_OPTION_FORMAT "Неверный формат опции %1.\n\0"
+    IDS_BAD_OPTION "Неверная опция %1.\n\0"
+    IDS_BAD_PARAMETER "Неверный параметр %1.\n\0"
+    IDS_DEST_MUST_BE_SPECIFIED "Имя или IP адрес узла назначения должно быть указано.\n\0"
+    IDS_COULD_NOT_INIT_WINSOCK "Не удается инициализировать winsock dll.\n\0"
+    IDS_UNKNOWN_HOST "Неизвестный хост %1.\n\0"
+    IDS_SRC_MUST_BE_SPECIFIED "IP адрес узла назначения должен быть указан.\n\0"
+    IDS_BAD_VALUE_OPTION_N "Неверное значение опции -n, диапазон доступных значений от 1 до %1!u!.\n\0"
+    IDS_ARPING_TO_FROM "ARPING %1 из %2\n\0"
+    IDS_MS "мс\0"
+    IDS_1MS "1мс\0"
+    IDS_REPLY_FROM "Unicast ответ от %1 [%2]  %3%4\n\0"
+    IDS_ARPING_STATISTICS "Отправлено %1!u! запросов\n\
+Получено %2!u! ответов\n\0"
+END
Index: applications/screensavers/blankscr/lang/ru-RU.rc
===================================================================
--- applications/screensavers/blankscr/lang/ru-RU.rc	(nonexistent)
+++ applications/screensavers/blankscr/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,15 @@
+/*
+ * PROJECT:     ReactOS Default ScreenSaver
+ * LICENSE:     Public Domain
+ * FILE:        applications/screensavers/blankscr/lang/ru-RU.rc
+ * PURPOSE:     Russian Language File for Blank Screen ScreenSaver
+ * TRANSLATOR:  Sergey Stopkin
+ */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE DISCARDABLE
+BEGIN
+    IDS_DESCRIPTION "Заставка ""Пустой экран"""
+    IDS_TEXT        "Эта заставка не имеет настраиваемых параметров."
+END
Index: applications/screensavers/blankscr/lang/uk-UA.rc
===================================================================
--- applications/screensavers/blankscr/lang/uk-UA.rc	(revision 72661)
+++ applications/screensavers/blankscr/lang/uk-UA.rc	(working copy)
@@ -1,7 +1,7 @@
 /*
  * PROJECT:     Default ScreenSaver
  * LICENSE:     Public Domain
- * FILE:        base/applications/screensavers/scrnsave/lang/uk-UA.rc
+ * FILE:        rosapps/applications/screensavers/blankscr/lang/uk-UA.rc
  * PURPOSE:     Ukraianian Language File for Default ScreenSaver
  * TRANSLATOR:  Artem Reznikov
  */
Index: applications/screensavers/blankscr/scrnsave.rc
===================================================================
--- applications/screensavers/blankscr/scrnsave.rc	(revision 72661)
+++ applications/screensavers/blankscr/scrnsave.rc	(working copy)
@@ -47,6 +47,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_SK_SK
     #include "lang/sk-SK.rc"
 #endif
Index: applications/screensavers/butterflies/lang/ru-RU.rc
===================================================================
--- applications/screensavers/butterflies/lang/ru-RU.rc	(nonexistent)
+++ applications/screensavers/butterflies/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,34 @@
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+IDD_DLG_SCREEN DIALOGEX DISCARDABLE  0, 0, 172, 57
+STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Параметры заставки ""Бабочки"""
+FONT 8, "MS Shell Dlg"
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,7,35,50,14
+    PUSHBUTTON      "Отмена",IDCANCEL,61,35,50,14
+    CONTROL         "Вращение бабочек",ROTATE,"Button",BS_AUTOCHECKBOX |
+                    WS_TABSTOP,56,15,70,8
+    PUSHBUTTON      "О программе",IDABOUT,115,35,50,14
+END
+
+IDD_DLG_ABOUT DIALOGEX DISCARDABLE  0, 0, 149, 79
+STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION ""
+FONT 8, "MS Shell Dlg"
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,48,58,56,14
+    CTEXT           "Заставка ""Бабочки""",IDC_STATIC,7,7,135,9
+    CTEXT           "Автор демо: NeHe ",IDC_STATIC,7,20,135,8
+    CTEXT           "http://nehe.gamedev.net",WEBPAGE1,7,29,135,8,SS_NOTIFY |
+                    NOT WS_GROUP
+    CTEXT           "Автор заставки: tHaPuTeR",IDC_STATIC,7,38,135,8,NOT
+                    WS_GROUP
+    CTEXT           "http://www.thaputer.com",WEBPAGE2,7,47,135,8,SS_NOTIFY |
+                    NOT WS_GROUP
+END
+
+STRINGTABLE DISCARDABLE
+BEGIN
+    IDS_DESCRIPTION         "Заставка ""Бабочки"""
+END
Index: applications/screensavers/butterflies/rsrc.rc
===================================================================
--- applications/screensavers/butterflies/rsrc.rc	(revision 72661)
+++ applications/screensavers/butterflies/rsrc.rc	(working copy)
@@ -30,6 +30,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_SK_SK
     #include "lang/sk-SK.rc"
 #endif
Index: applications/screensavers/circles/circles.rc
===================================================================
--- applications/screensavers/circles/circles.rc	(revision 72661)
+++ applications/screensavers/circles/circles.rc	(working copy)
@@ -36,6 +36,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_SK_SK
     #include "lang/sk-SK.rc"
 #endif
Index: applications/screensavers/circles/lang/ru-RU.rc
===================================================================
--- applications/screensavers/circles/lang/ru-RU.rc	(nonexistent)
+++ applications/screensavers/circles/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,15 @@
+/*
+ * PROJECT:     ReactOS Default ScreenSaver
+ * LICENSE:     Public Domain
+ * FILE:        applications/screensavers/blankscr/lang/ru-RU.rc
+ * PURPOSE:     Russian Language File for Circle ScreenSaver
+ * TRANSLATOR:  Sergey Stopkin
+ */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE DISCARDABLE
+BEGIN
+    IDS_DESCRIPTION "Заставка ""Круги"""
+    IDS_TEXT        "Эта заставка не имеет настраиваемых параметров."
+END
Index: applications/screensavers/cylfrac/cylfrac.rc
===================================================================
--- applications/screensavers/cylfrac/cylfrac.rc	(revision 72661)
+++ applications/screensavers/cylfrac/cylfrac.rc	(working copy)
@@ -48,6 +48,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_SK_SK
     #include "lang/sk-SK.rc"
 #endif
Index: applications/screensavers/cylfrac/lang/ru-RU.rc
===================================================================
--- applications/screensavers/cylfrac/lang/ru-RU.rc	(nonexistent)
+++ applications/screensavers/cylfrac/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,16 @@
+/*
+ * PROJECT:     Cylinders fractal ScreenSaver
+ * LICENSE:     Public Domain
+ * FILE:        applications/screensavers/cylfrac/lang/ru-RU.rc
+ * PURPOSE:     Russian Language File for Cylinders fractal ScreenSaver
+ * TRANSLATOR:  Sergey Stopkin
+ */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE DISCARDABLE
+BEGIN
+    IDS_DESCRIPTION "Заставка ""Cylinders fractal"""
+    IDS_TITLE       "О программе"
+    IDS_TEXT        "Cylinders fractal от unC0Rr.\nСпециально для ReactOS."
+END
Index: applications/screensavers/matrix/lang/ru-RU.rc
===================================================================
--- applications/screensavers/matrix/lang/ru-RU.rc	(nonexistent)
+++ applications/screensavers/matrix/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,61 @@
+/*
+ * PROJECT:     Matrix ScreenSaver
+ * LICENSE:     Public Domain
+ * FILE:        applications/screensavers/matrix/lang/ru-RU.rc
+ * PURPOSE:     Russian Language File for Matrix ScreenSaver
+ * TRANSLATOR:  Sergey Stopkin
+ */
+
+#include "resource.h"
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+IDD_CONFIG DIALOGEX DISCARDABLE  0, 0, 340, 183
+STYLE DS_SHELLFONT | DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Параметры заставки ""Матрица"""
+FONT 8, "MS Shell Dlg"
+BEGIN
+    GROUPBOX        "Скорость декодирования",IDC_STATIC,7,7,128,36
+    LTEXT           "Медленнее",IDC_STATIC,13,24,22,8
+    CONTROL         "Slider1",IDC_SLIDER1,"msctls_trackbar32",TBS_AUTOTICKS |
+                    TBS_BOTH | WS_TABSTOP,38,17,62,22
+    LTEXT           "Быстрее",IDC_STATIC,104,24,20,8
+    GROUPBOX        "Плотность &шифра",IDC_STATIC,7,50,128,36
+    LTEXT           "Меньше",IDC_STATIC,13,67,19,8
+    CONTROL         "Slider1",IDC_SLIDER2,"msctls_trackbar32",TBS_AUTOTICKS |
+                    TBS_BOTH | WS_TABSTOP,38,60,62,22
+    LTEXT           "Больше",IDC_STATIC,104,67,23,8
+    GROUPBOX        "Скорость показа сооб&щений",IDC_MSGSPEEDGRP,7,93,127,36
+    LTEXT           "Медленнее",IDC_STATIC,13,110,22,8
+    CONTROL         "Slider3",IDC_SLIDER3,"msctls_trackbar32",TBS_AUTOTICKS |
+                    TBS_BOTH | WS_TABSTOP,38,103,62,22
+    LTEXT           "Быстрее",IDC_STATIC,104,110,22,8
+    GROUPBOX        "&Размер шрифта",IDC_STATIC,7,137,127,36
+    LTEXT           "Меньше",IDC_STATIC,13,153,24,8
+    CONTROL         "Slider3",IDC_SLIDER4,"msctls_trackbar32",TBS_AUTOTICKS |
+                    TBS_BOTH | WS_TABSTOP,38,146,62,22
+    LTEXT           "Больше",IDC_STATIC,104,153,25,8
+    GROUPBOX        "&Закодированные сообщения",IDC_STATIC,145,7,188,142
+    COMBOBOX        IDC_COMBO1,153,22,172,62,CBS_DROPDOWN | WS_VSCROLL |
+                    WS_TABSTOP
+    CONTROL         "",IDC_PREVIEW,"Static",SS_LEFTNOWORDWRAP |
+                    SS_CENTERIMAGE | WS_GROUP,154,39,116,72
+    PUSHBUTTON      "&Добавить",IDC_ADD,280,41,44,18
+    PUSHBUTTON      "&Удалить",IDC_REMOVE,280,66,44,18
+    CONTROL         "Случайные сообщения",IDC_RANDOM,"Button",BS_AUTOCHECKBOX |
+                    WS_TABSTOP,151,134,85,10
+    DEFPUSHBUTTON   "OK",IDOK,222,162,50,14
+    PUSHBUTTON      "Отмена",IDCANCEL,283,162,50,14
+    LTEXT           "&Имя шрифта:",IDC_STATIC,151,118,38,8
+    COMBOBOX        IDC_COMBO2,195,116,130,71,CBS_DROPDOWNLIST | CBS_SORT |
+                    WS_VSCROLL | WS_TABSTOP
+    CONTROL         "&Жирное начертание",IDC_BOLD,"Button",BS_AUTOCHECKBOX |
+                    BS_MULTILINE | WS_TABSTOP,247,134,46,10
+    CTEXT           "Заставка ""Матрица"" www.catch22.org.uk",IDC_ABOUT,140,
+                    158,75,18
+END
+
+STRINGTABLE DISCARDABLE
+BEGIN
+    IDS_DESCRIPTION         "Заставка ""Матрица"""
+END
Index: applications/screensavers/matrix/rsrc.rc
===================================================================
--- applications/screensavers/matrix/rsrc.rc	(revision 72661)
+++ applications/screensavers/matrix/rsrc.rc	(working copy)
@@ -42,6 +42,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_SK_SK
     #include "lang/sk-SK.rc"
 #endif
Index: applications/screensavers/mazescr/lang/ru-RU.rc
===================================================================
--- applications/screensavers/mazescr/lang/ru-RU.rc	(nonexistent)
+++ applications/screensavers/mazescr/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,53 @@
+/*
+ * PROJECT:     ReactOS Default ScreenSaver
+ * LICENSE:     Public Domain
+ * FILE:        applications/screensavers/mazescr/lang/ru-RU.rc
+ * PURPOSE:     Russian Language File for Maze ScreenSaver
+ * TRANSLATOR:  Sergey Stopkin
+ */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+IDD_DLG_SCREEN DIALOGEX DISCARDABLE  0, 0, 276, 112
+STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Maze ScreenSaver Settings"
+FONT 8, "MS Shell Dlg"
+BEGIN
+    LTEXT           "Максимальный размер:",IDC_STATIC,7,7,90,12,SS_CENTERIMAGE
+    CONTROL         "Slider1",IDC_SLIDER_SIZE,"msctls_trackbar32",TBS_BOTH | TBS_NOTICKS | WS_TABSTOP,101,7,140,12
+    CTEXT           "Static",IDC_TEXT_SIZE,245,7,24,12,SS_CENTERIMAGE,WS_EX_STATICEDGE
+    LTEXT           "Задержка перед выбором:",IDC_STATIC,7,28,90,12,SS_CENTERIMAGE
+    CONTROL         "Slider2",IDC_SLIDER_PRESD,"msctls_trackbar32",TBS_BOTH | TBS_NOTICKS | WS_TABSTOP,101,28,140,12
+    CTEXT           "Static",IDC_TEXT_PRESD,245,28,24,12,SS_CENTERIMAGE,WS_EX_STATICEDGE
+    LTEXT           "Задержка после выбора:",IDC_STATIC,7,49,90,12,SS_CENTERIMAGE
+    CONTROL         "Slider3",IDC_SLIDER_POSTSD,"msctls_trackbar32",TBS_BOTH | TBS_NOTICKS | WS_TABSTOP,101,49,140,12
+    CTEXT           "Static",IDC_TEXT_POSTSD,245,49,24,12,SS_CENTERIMAGE,WS_EX_STATICEDGE
+    LTEXT           "Задержка выбора:",IDC_STATIC,7,70,90,12,SS_CENTERIMAGE
+    CONTROL         "Slider4",IDC_SLIDER_SD,"msctls_trackbar32",TBS_BOTH | TBS_NOTICKS | WS_TABSTOP,101,70,140,12
+    CTEXT           "Static",IDC_TEXT_SD,245,70,24,12,SS_CENTERIMAGE,WS_EX_STATICEDGE
+    DEFPUSHBUTTON   "OK",IDOK,59,91,50,14
+    PUSHBUTTON      "Отмена",IDCANCEL,113,91,50,14
+    PUSHBUTTON      "О программе",IDABOUT,167,91,50,14
+END
+
+IDD_DLG_ABOUT DIALOGEX DISCARDABLE  0, 0, 229, 121
+STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "О заставке ""Лабиринт"""
+FONT 8, "MS Shell Dlg"
+BEGIN
+    CTEXT           "Maze ScreenSaver 1.0",IDC_STATIC,7,7,215,9
+    LTEXT           "[06-21-85] Martin Weiss - Original Code",IDC_STATIC,7,20,215,8
+    LTEXT           "[01-29-88] Dave Lemke - Hacked for X11",IDC_STATIC,7,29,215,8
+    LTEXT           "[10-04-88] Richard Hess - UnHacked for X11",IDC_STATIC,7,38,215,8
+    LTEXT           "[03-03-93] Jim Randell - UnHacked for X11",IDC_STATIC,7,47,215,8
+    LTEXT           "[03-07-93] Jamie Zawinski - Cleanup and Code tidiness",IDC_STATIC,7,56,215,8
+    LTEXT           "[10-08-94] Ge van Geldorp - Ported to Windows",IDC_STATIC,7,65,215,8
+    LTEXT           "[08-15-03] Ge van Geldorp - Ported to ReactOS",IDC_STATIC,7,74,215,8
+    CTEXT           "R.I.P. Ge van Geldorp, we miss you!",IDC_STATIC,7,87,215,10,SS_SUNKEN
+    DEFPUSHBUTTON   "OK",IDOK,87,100,56,14
+END
+
+STRINGTABLE DISCARDABLE
+BEGIN
+    IDS_DESCRIPTION         "Заставка ""Лабиринт"""
+END
Index: applications/screensavers/mazescr/maze.rc
===================================================================
--- applications/screensavers/mazescr/maze.rc	(revision 72661)
+++ applications/screensavers/mazescr/maze.rc	(working copy)
@@ -27,6 +27,9 @@
 #ifdef LANGUAGE_EN_US
     #include "lang/en-US.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_ZH_CN
     #include "lang/zh-CN.rc"
 #endif
Index: applications/sysutils/ctm/lang/ru-RU.rc
===================================================================
--- applications/sysutils/ctm/lang/ru-RU.rc	(revision 72661)
+++ applications/sysutils/ctm/lang/ru-RU.rc	(working copy)
@@ -11,7 +11,7 @@
    IDS_COLUMN_PID          "PID  "
    IDS_COLUMN_CPU          "ЦП"
    IDS_COLUMN_MEM          "Использование памяти"
-   IDS_COLUMN_MEM_UNIT		"КБ"
+   IDS_COLUMN_MEM_UNIT     "КБ"
    IDS_COLUMN_PF           "Ошибок страницы"
 
    IDS_IDLE_PROCESS        "Бездействие системы"
Index: applications/sysutils/systeminfo/lang/ru-RU.rc
===================================================================
--- applications/sysutils/systeminfo/lang/ru-RU.rc	(nonexistent)
+++ applications/sysutils/systeminfo/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,80 @@
+/*
+ * PROJECT:     System Information
+ * LICENSE:     GPL - See COPYING in the top level directory
+ * FILE:        rosapps/sysutils/systeminfo/lang/ru-RU.rc
+ * PURPOSE:     Russian Language File for systeminfo
+ * TRANSLATOR:  Sergey Stopkin
+ */
+
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE DISCARDABLE
+BEGIN
+
+IDS_USAGE, "SYSTEMINFO [/S система [/U имяПользователя [/P [пароль]]]] [/FO формат] [/NH]\n\n\
+Описание:\n\
+  Эта утилита командной строки предоставляет администратору возможность\n\
+  запрашивать основную информацию о конфигурации системы.\n\n\
+Список параметров:\n\
+  /S      система          Определяет удаленную систему для подключения.\n\n\
+  /U      [домен\\]польз.  Определяет контекст пользователя, под которым\n\
+                           выполняется данная команда.\n\n\
+  /P      [password]       Задает пароль для данного контекста пользователя.\n\
+                           Запрашивает ввод пароля, если он не был задан.\n\n\
+  /FO     формат           Определяет формат, в котором отображаются\n\
+                           выходные данные.\n\
+                           Допустимые форматы: ""TABLE"", ""LIST"", ""CSV"".\n\n\
+  /NH                      Указывает, что ""Заголовок столбца""\n\
+                           не должен отображаться в выводе.\n\
+                           Допускается для форматов ""TABLE"" и ""CSV"".\n\n\
+  /?                       Показать эту справку/примеры.\n\n\
+Примеры:\n\
+  SYSTEMINFO\n\
+  SYSTEMINFO /?\n\
+  SYSTEMINFO /S система\n\
+  SYSTEMINFO /S система /U user\n\
+  SYSTEMINFO /S система /U домен\\пользователь /P пароль /FO TABLE\n\
+  SYSTEMINFO /S система /FO LIST\n\
+  SYSTEMINFO /S система /FO CSV /NH\n"
+
+IDS_HOST_NAME,               "Имя компьютера"
+IDS_OS_NAME,                 "Имя ОС"
+IDS_OS_VERSION,              "Версия ОС"
+IDS_BUILD,                   "Сборка"
+IDS_OS_BUILD_TYPE,           "Тип сборки ОС"
+IDS_REG_OWNER,               "Зарегистрированный пользователь"
+IDS_REG_ORG,                 "Зарегистрированная организация"
+IDS_PRODUCT_ID,              "ID продукта"
+IDS_INST_DATE,               "Дата установки"
+IDS_UP_TIME,                 "Время работы системы"
+IDS_UP_TIME_FORMAT,          "%u дней, %u часов, %u минут, %u секунд"
+IDS_SYS_MANUFACTURER,        "Производитель системы"
+IDS_SYS_MODEL,               "Модель системы"
+IDS_SYS_TYPE,                "Тип системы"
+IDS_PROCESSORS,              "Процессор(-ы)"
+IDS_PROCESSORS_FORMAT,       "%u процессор(-ов) установлено."
+IDS_BIOS_DATE,               "Дата BIOS"
+IDS_BIOS_VERSION,            "Версия BIOS"
+IDS_ROS_DIR,                 "Папка ReactOS"
+IDS_SYS_DIR,                 "Системная папка"
+IDS_BOOT_DEV,                "Загрузочное устройство"
+IDS_SYS_LOCALE,              "Язык системы"
+IDS_INPUT_LOCALE,            "Язык ввода"
+IDS_TIME_ZONE,               "Часовой пояс"
+IDS_TOTAL_PHYS_MEM,          "Всего физической памяти"
+IDS_AVAIL_PHISICAL_MEM,      "Доступно физической памяти"
+IDS_VIRT_MEM_MAX,            "Виртуальная память: Макс. размер"
+IDS_VIRT_MEM_AVAIL,          "Виртуальная память: Доступно"
+IDS_VIRT_MEM_INUSE,          "Виртуальная память: Используется"
+IDS_PAGEFILE_LOC,            "Расположение файла подкачки"
+IDS_DOMAIN,                  "Домен"
+IDS_NETWORK_CARDS,           "Сетевая карта(-ы)"
+IDS_NETWORK_CARDS_FORMAT,    "%u Установлено."
+IDS_CONNECTION_NAME,         "Имя соединения"
+IDS_STATUS,                  "Статус"
+IDS_MEDIA_DISCONNECTED,      "Носитель отключен"
+IDS_DHCP_ENABLED,            "DHCP Разрешен"
+IDS_NO,                      "Нет"
+IDS_IP_ADDRESSES,            "IP адрес(-а)"
+
+END